use std::thread;
use std::sync::Mutex;
use std::sync::MutexGuard;
use std::sync::Arc;
use std::thread::JoinHandle;

fn main() {
    let c: Arc<Mutex<i32>> = Arc::new(Mutex::new(0));
    let mut handles: Vec<JoinHandle<()>> = vec![];

    for _ in 0..10 {
        let c: Arc<Mutex<i32>> = Arc::clone(&c);
        let handle: JoinHandle<()> = thread::spawn(move || {
            let mut num: MutexGuard<i32> = c.lock().unwrap();
            *num +=1;
        });
        handles.push(handle);
    }

    for handle in handles {
        handle.join().unwrap();
    }

    println!("c = {:?}", *c.lock().unwrap());
}
